﻿Imports System.Collections
Imports System.Collections.Generic
Imports System.Linq
Imports System.Windows.Controls


Imports IdeaBlade.EntityModel
Imports IdeaBlade.EntityModel.Security


Partial Public Class MainPage
    Inherits UserControl
    Public Sub New()
        InitializeComponent()
        CreateEntityManager()
        Login()
    End Sub

    Private Async Sub Login()
        Dim cred = New LoginCredential("demo1", "demo2", "demo3")

        WriteMessage("Logging in ...")

        Try
            Dim ac = Await Authenticator.Instance.LoginAsync(cred)
            Authenticator.Instance.DefaultAuthenticationContext = ac
            WriteMessage("Logged in")
            LoadData()
        Catch e As Exception
            WriteMessage(e.Message)
        End Try

    End Sub

    Private Sub CreateEntityManager()
        _mgr = New EntityManager()
    End Sub

#Region "LoadData"

    Private Async Sub LoadData()

        Try
            Dim results = Await _mgr.ExecuteQueryAsync(Of State)(_mgr.States.Where(Function(s) s.Lower49))
            _states.Clear()
            For Each aState As State In results
                _states.Add(aState)
            Next
            _statesDataGrid.ItemsSource = _states
            ReportFetchCount(results)
        Catch e As Exception
            WriteMessage(e.Message)
        End Try

    End Sub

#End Region

    Private Sub ReportFetchCount(ByVal results As IEnumerable)
        If results Is Nothing Then
            WriteMessage("Fetch failed")
        Else
            WriteMessage(String.Format("Retrieved {0} items.", results.Cast(Of [Object])().Count()))
        End If
    End Sub

    Public Sub WriteMessage(ByVal msg As String)
        _statusTextBlock.Text += Environment.NewLine & msg
    End Sub

#Region "Private Fields"
    Private _mgr As EntityManager
    Private _states As New List(Of State)()
#End Region
End Class